/*
THIS IS A GENERATED/BUNDLED FILE BY ROLLUP
if you want to view the source visit the plugins github repository
*/

(function () {
    'use strict';

    const text = {
        toggle_title: ["操作", "Actions"],
        toggle_desc_toc_on: [
            "现在点击卡片可获取其下所有笔记以在Obsidian生成目录",
            "tap/click on parent note can now recursively fetch all children notes to generate toc in Obsidian",
        ],
        hint_toc_success: [
            "成功从该笔记获得目录：",
            "Successfully fetch toc from note: ",
        ],
        warn_toc_enabled: [
            "⚠️仍处于获取目录模式",
            "⚠️Fetch TOC Mode is still enabled",
        ],
        hint_addon_enabled: [
            "注意：该插件启用时，选择文本或笔记均会唤醒Obsidian",
            "Note: With addon enabled, selecting text or notes will open Obsidian",
        ],
        off: ["⛔️关闭", "⛔️Disable "],
        on: ["✅开启", "✅Enable "],
        disabled: ["已关闭", " Disabled"],
        enabled: ["已开启", " Enabled"],
        toc: ["获取目录模式", "TOC Fetch Mode"],
        addon: ["Obsidian Bridge", "Obsidian Bridge"],
        cancel: ["取消", "Cancel"],
        missing_param: ["笔记缺少参数", "Missing params"],
    };
    const getLanguage = () => NSLocale.preferredLanguages().length
        ? NSLocale.preferredLanguages()[0].substring(0, 2)
        : "en";
    const getText = (key) => getLanguage() === "zh" ? text[key][0] : text[key][1];

    /**
     * @returns when note missing params, return error message
     */
    const scanToc = (note) => {
        const depth = 99;
        let invaild = [], bookMd5s = new Set();
        const scan = (obj, accu = 0) => {
            const requiredKeys = ["noteId", "childNotes"], keys = requiredKeys.concat("docMd5", "startPage", "endPage", "noteTitle", "excerptText", "toc", "notesText");
            if (requiredKeys.some((k) => {
                const result = obj[k] === null || obj[k] === undefined;
                if (result)
                    invaild.push(`${obj.noteId} ${getText("missing_param")}: ${k}`);
                return result;
            }))
                return null;
            let out = {};
            for (const key of keys) {
                let value;
                if (accu < depth) {
                    if (key === "docMd5" && obj.docMd5) {
                        bookMd5s.add(obj.docMd5);
                        value = obj.docMd5;
                    }
                    else if (key === "childNotes" && Array.isArray(obj[key])) {
                        try {
                            value = obj.childNotes
                                .map((n) => scan(n, accu + 1))
                                .filter((n) => n !== null);
                        }
                        catch (error) {
                            value = `Error scaning: ${key} accu: ${accu}`;
                        }
                    }
                }
                if (!value)
                    value = obj[key];
                Object.defineProperty(out, key, {
                    value,
                    writable: true,
                    enumerable: true,
                    configurable: true,
                });
            }
            return out;
        };
        const result = scan(note);
        if (!result) {
            JSB.log("🌈🌈🌈 MNLOG toc: invaild param\n" + invaild.join("\n"));
            throw new EvalError("invaild param: " + invaild.join(","));
        }
        return [result, [...bookMd5s]];
    };
    const scanNote = (note, depth = 1) => {
        let bookMd5s = new Set();
        const generalScan = getScanFunc(depth), scan = (obj, dive, accu = 0) => {
            let out = {};
            for (const k of getAllProperties(obj)) {
                const key = k;
                let value;
                if (accu < depth) {
                    if (obj[key] instanceof Date) {
                        value = obj[key].getTime();
                    }
                    else if (key === "docMd5" && obj.docMd5) {
                        bookMd5s.add(obj.docMd5);
                        value = obj.docMd5;
                    }
                    else if (key === "parentNote" &&
                        obj.parentNote &&
                        (dive === undefined || !dive)) {
                        try {
                            value = scan(obj.parentNote, false, accu + 1);
                        }
                        catch (error) {
                            value = `Error scaning: ${key} accu: ${accu}`;
                        }
                    }
                    else if (key === "childNotes" &&
                        (dive === undefined || dive) &&
                        Array.isArray(obj[key]) &&
                        accu < depth - 1) {
                        try {
                            value = obj.childNotes.map((v) => scan(v, true, accu + 1));
                        }
                        catch (error) {
                            value = `Error scaning: ${key} accu: ${accu}`;
                        }
                    }
                    else if (key === "excerptPic") {
                        try {
                            value = generalScan(obj.excerptPic, false, accu + 1);
                        }
                        catch (error) {
                            value = `Error scaning: ${key} accu: ${accu}`;
                        }
                    }
                }
                if (!value)
                    value = obj[key];
                Object.defineProperty(out, key, {
                    value,
                    writable: true,
                    enumerable: true,
                    configurable: true,
                });
            }
            return out;
        };
        return [scan(note), [...bookMd5s]];
    };
    const getScanFunc = (depth) => {
        const scan = (obj, dive, accu = 0) => {
            if (typeof obj !== "undefined" && obj !== null) {
                let out = {};
                for (const key of getAllProperties(obj)) {
                    let value;
                    if (accu < depth) {
                        if (obj[key] instanceof Date) {
                            value = obj[key].getTime();
                        }
                        else if (key === "parentNote" &&
                            (dive === undefined || !dive) &&
                            isMbBookNote(obj[key])) {
                            try {
                                value = scan(obj[key], false, accu + 1);
                            }
                            catch (error) {
                                value = `Error scaning: ${key} accu: ${accu}`;
                            }
                        }
                        else if (key === "childNotes" &&
                            (dive === undefined || dive) &&
                            Array.isArray(obj[key]) &&
                            accu < depth - 1) {
                            try {
                                value = obj[key].map((v) => scan(v, true, accu + 1));
                            }
                            catch (error) {
                                value = `Error scaning: ${key} accu: ${accu}`;
                            }
                        }
                        else if (key === "excerptPic") {
                            try {
                                value = scan(obj[key], false, accu + 1);
                            }
                            catch (error) {
                                value = `Error scaning: ${key} accu: ${accu}`;
                            }
                        }
                    }
                    if (!value)
                        value = obj[key];
                    Object.defineProperty(out, key, {
                        value,
                        writable: true,
                        enumerable: true,
                        configurable: true,
                    });
                }
                return out;
            }
            else {
                return undefined;
            }
        };
        return scan;
    };
    const scanObject = (obj, depth = 1) => {
        const scan = getScanFunc(depth);
        return scan(obj);
    };
    const baseProps = (() => {
        let allProps = [], curr = {};
        do {
            let props = Object.getOwnPropertyNames(curr);
            props.forEach((prop) => {
                if (allProps.indexOf(prop) === -1)
                    allProps.push(prop);
            });
        } while ((curr = Object.getPrototypeOf(curr)));
        return allProps;
    })();
    const getAllProperties = (obj) => {
        let allProps = [], curr = obj;
        do {
            let props = Object.getOwnPropertyNames(curr);
            props.forEach((prop) => {
                if (allProps.indexOf(prop) === -1 && baseProps.indexOf(prop) === -1)
                    allProps.push(prop);
            });
        } while ((curr = Object.getPrototypeOf(curr)));
        return allProps;
    };
    const isMbBookNote = (obj) => {
        return ((obj === null || obj === void 0 ? void 0 : obj.noteId) !== undefined &&
            (obj === null || obj === void 0 ? void 0 : obj.childNotes) !== undefined &&
            Array.isArray(obj.childNotes));
    };

    const showHUD = (message, duration = 2) => {
        Application.sharedInstance().showHUD(message, self.window, duration);
    };
    /**
     * Copy to Clipboard
     */
    const copy = (content) => {
        // @ts-ignore
        let pasteBoard = UIPasteboard.generalPasteboard();
        pasteBoard.string = content;
    };
    /**
     * Get Objective-C class declaration
     */
    const getObjCClassDeclar = (name, type) => `${name} : ${type}`;
    const isMac = () => Application.sharedInstance().osType === 2 /* macOS */;

    const pluginName = "obsidian-bridge";
    const toggleHandlerName = `toggle${pluginName}`;
    const addonOnName = `${pluginName}_on`;
    const togglePlugin = (sender) => {
        const toggleAddon = () => {
            self[addonOnName] = !self[addonOnName];
            NSUserDefaults.standardUserDefaults().setObjectForKey(self[addonOnName], `marginnote_${pluginName}`);
            Application.sharedInstance()
                .studyController(self.window)
                .refreshAddonCommands();
        };
        if (!self[addonOnName]) {
            toggleAddon();
            showHUD(isMac() ? getText("addon") + getText("enabled") : getText("hint_addon_enabled"));
        }
        else
            UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(getText("toggle_title"), "", 0 /* Default */, getText("cancel"), [
                (self.tocMode ? getText("off") : getText("on")) + getText("toc"),
                (self[addonOnName] ? getText("off") : getText("on")) + getText("addon"),
            ], (alert, buttonIndex) => {
                switch (buttonIndex) {
                    case 1:
                        self.tocMode = !self.tocMode;
                        if (self.tocMode)
                            showHUD(getText("toggle_desc_toc_on"));
                        break;
                    case 2:
                        toggleAddon();
                        showHUD(getText("addon") + getText("disabled"));
                        break;
                    case 0:
                        break;
                    default:
                        JSB.log("🌈🌈🌈 MNLOG tapBlock: Unexpected button pressed %o", alert.buttonTitleAtIndex(buttonIndex));
                        break;
                }
            });
    };

    class PopupRecorder {
        constructor() {
            this.history = new Array(null, null);
            this.addTime = new Array(null, null);
        }
        /**
         * @returns add time
         */
        push(obj) {
            this.history.shift(); //去除过期id（第一个）
            this.history.push(obj);
            this.addTime.shift(); //去除过期id（第一个）
            const addTime = Date.now();
            this.addTime.push(addTime);
            return addTime;
        }
        get last() {
            const data = this.history[1];
            const addTime = this.addTime[1];
            if (data && addTime)
                return { data, addTime };
            else
                return null;
        }
        isDuplicate(time) {
            var _a;
            return time - ((_a = this.addTime[1]) !== null && _a !== void 0 ? _a : 0) < 500;
        }
    }

    const getBook = (docMd5) => {
        const bookObj = docMd5 && typeof docMd5 === "string"
            ? Database.sharedInstance().getDocumentById(docMd5)
            : null;
        return bookObj ? scanObject(bookObj) : null;
    };
    const getLastAndSendTime = (data) => {
        const rec = self.recorder, last = rec.last;
        return { last, sendTime: rec.push(data) };
    };
    const getBody_Sel = (sel) => {
        const { last, sendTime } = getLastAndSendTime(sel);
        if (sel.book)
            sel.book = scanObject(sel.book);
        return {
            type: "sel",
            sendTime,
            data: sel,
            last,
        };
    };
    const arrToObj = (cvt, ...arrs) => {
        let obj = {};
        for (const id of new Set(arrs.flat())) {
            const val = cvt(id);
            if (val)
                obj[id] = val;
        }
        return obj;
    };
    const getLinkedNotes = (note) => {
        var _a, _b;
        const { linkedNotes, comments } = note, linkedIds1 = (_a = linkedNotes === null || linkedNotes === void 0 ? void 0 : linkedNotes.map((v) => v.noteid).filter((v) => Boolean(v))) !== null && _a !== void 0 ? _a : [], linkedIds2 = (_b = comments
            .filter((c) => c.type === "LinkNote")
            .map((v) => v.noteid)) !== null && _b !== void 0 ? _b : [];
        if (linkedIds1.length === 0 && linkedIds2.length === 0)
            return [{}, [], []];
        let book = [], media = [], map = arrToObj((id) => {
            const note = Database.sharedInstance().getNoteById(id);
            if (!note)
                return null;
            const [data, bookMd5s] = scanNote(note, 1);
            book.push(bookMd5s);
            media.push(getMediaIds(note));
            return data;
        }, linkedIds1, linkedIds2);
        return [map, book.flat(), media.flat()];
    };
    const getMediaIds = (note) => {
        var _a, _b;
        const videoId = (_a = note.excerptPic) === null || _a === void 0 ? void 0 : _a.video, mediaIds = (_b = note.mediaList) === null || _b === void 0 ? void 0 : _b.split("-").filter((id) => id !== videoId);
        return mediaIds !== null && mediaIds !== void 0 ? mediaIds : [];
    };
    const getBody_Note = (note) => {
        const [data, bookMd5s] = scanNote(note, 1), { last, sendTime } = getLastAndSendTime(data), [linkedNotes, bookL, mediaL] = getLinkedNotes(note), bookMap = arrToObj((id) => getBook(id), bookMd5s, bookL), mediaMap = arrToObj((id) => {
            var _a;
            const mediaData = (_a = Database.sharedInstance()
                .getMediaByHash(id)) === null || _a === void 0 ? void 0 : _a.base64Encoding();
            return mediaData && mediaData.startsWith("iVBORw0K") ? mediaData : null;
        }, getMediaIds(note), mediaL);
        return {
            type: "note",
            sendTime,
            bookMap,
            mediaMap,
            linkedNotes,
            data,
            last,
        };
    };
    const getBody_Toc = (note) => {
        // if (note.parentNote) return;
        const result = scanToc(note);
        const [data, bookMd5s] = result, { last, sendTime } = getLastAndSendTime(data), bookMap = arrToObj((id) => getBook(id), bookMd5s);
        return {
            type: "toc",
            sendTime,
            bookMap,
            data,
            last,
        };
    };

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    var jsonurl_min = {exports: {}};

    /*!
     * jsonurl.js v1.1.4
     * (c) 2021 David MacCormack
     * Released under the MIT License.
     */

    (function (module, exports) {
    !function(e,t){module.exports=t();}(commonjsGlobal,(function(){function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n);}}function r(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}function n(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&o(e,t);}function i(e){return (i=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function o(e,t){return (o=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function s(){if("undefined"==typeof Reflect||!Reflect.construct)return !1;if(Reflect.construct.sham)return !1;if("function"==typeof Proxy)return !0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return !1}}function a(e,t,r){return (a=s()?Reflect.construct:function(e,t,r){var n=[null];n.push.apply(n,t);var i=new(Function.bind.apply(e,n));return r&&o(i,r.prototype),i}).apply(null,arguments)}function u(e){var t="function"==typeof Map?new Map:void 0;return (u=function(e){if(null===e||(r=e,-1===Function.toString.call(r).indexOf("[native code]")))return e;var r;if("function"!=typeof e)throw new TypeError("Super expression must either be null or a function");if(void 0!==t){if(t.has(e))return t.get(e);t.set(e,n);}function n(){return a(e,arguments,i(this).constructor)}return n.prototype=Object.create(e.prototype,{constructor:{value:n,enumerable:!1,writable:!0,configurable:!0}}),o(n,e)})(e)}function c(e,t){return !t||"object"!=typeof t&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function p(e){var t=s();return function(){var r,n=i(e);if(t){var o=i(this).constructor;r=Reflect.construct(n,arguments,o);}else r=n.apply(this,arguments);return c(this,r)}}var l="JSON->URL: expected literal value",h="JSON->URL: unexpected character",f="JSON->URL: unexpected end of text inside composite",d="JSON->URL: unexpected text after composite",y="JSON->URL: MaxParseValues exceeded",v="JSON->URL: the empty string is not allowed",w="JSON->URL: invalid escape sequence",m="JSON->URL: invalid percent-encoded sequence",x="JSON->URL: expected object value";function O(e,t){return void 0===t?e:e+" at position "+t}var b=16,E=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,6,6,48,10,20,20,6,6,20,6,6,6,6,6,6,6,6,6,6,6,6,6,20,6,0,48,0,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0,0,0,0,6,0,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,0,0,0,6,0];function g(e){return e>127?0:E[e]}var A=function(){function t(r){e(this,t),this.setOrDefault(r,"allowEmptyUnquotedValues"),this.setOrDefault(r,"allowEmptyUnquotedKeys"),this.setOrDefault(r,"AQF"),this.setOrDefault(r,"coerceNullToEmptyString"),this.setOrDefault(r,"impliedArray"),this.setOrDefault(r,"impliedObject"),this.setOrDefault(r,"impliedStringLiterals"),this.setOrDefault(r,"noEmptyComposite"),this.setOrDefault(r,"wwwFormUrlEncoded");}return r(t,[{key:"setOrDefault",value:function(e,t,r){void 0!==e&&t in e?t in this||(this[t]=e[t]):void 0===r||t in this||(this[t]=r);}},{key:"setOverride",value:function(e,t){void 0!==e&&t in e&&(this[t]=e[t]);}},{key:"setOrDefaultInt",value:function(e,t,r){this.setOrDefault(e,t,void 0===r?r:parseInt(r));}}]),t}(),S=function(t){n(o,t);var i=p(o);function o(t,r){var n;return e(this,o),(n=i.call(this,t)).setOrDefault(t,"emptyValue"),n.setOrDefault(r,"emptyValue",{}),n.setOverride(t,"getMissingValue"),n.setOrDefaultInt(t,"maxParseChars"),n.setOrDefaultInt(r,"maxParseChars",32768),n.setOrDefaultInt(t,"maxParseDepth"),n.setOrDefaultInt(r,"maxParseDepth",32),n.setOrDefaultInt(t,"maxParseValues"),n.setOrDefaultInt(r,"maxParseValues",4096),n.setOrDefault(t,"nullValue"),n.setOrDefault(r,"nullValue",null),n}return r(o,[{key:"getMissingValue",value:function(e,t){throw new SyntaxError(O(x,t))}}]),o}(A),V=function(t){n(i,t);var r=p(i);function i(t){var n;e(this,i),n=r.call(this,t);var o=!(void 0===t||!("impliedStringLiterals"in t)||!t.impliedStringLiterals)||void 0;return n.setOrDefault(t,"allowEmptyUnquotedValues",o),n.setOrDefault(t,"allowEmptyUnquotedKeys",o),n.setOrDefault(t,"callFunctions"),n.setOrDefault(t,"isImplied"),n.setOrDefault(t,"ignoreNullArrayMembers",o),n.setOrDefault(t,"ignoreNullObjectMembers",o),n.setOrDefault(t,"ignoreUndefinedArrayMembers",o),n.setOrDefault(t,"ignoreUndefinedObjectMembers",o),n.isImplied=n.isImplied||n.impliedArray||n.impliedObject,n}return i}(A),k=/\+/g,L=/ /g,U=/(![\s\S]?)/g,C=/^[-A-Za-z0-9._~!$*;=@?/ ][-A-Za-z0-9._~!$*;=@?/' ]*$/,j=/^[-A-Za-z0-9._~!$*,;=@?/(),: ]+$/,D=/^(?:true|false|null|(?:[-]?[0-9]+(?:[.][0-9]+)?(?:[eE][-+]?[0-9]+)?))$/,P=/[(),:]|%2[04]|%3B/gi,R={"%20":"+","%24":"$","(":"%28",")":"%29",",":"%2C",":":"%3A","%3B":";"},N=/[!(),:]|%2[01489C]|%3[AB]/gi,F={"%20":"+","%21":"!!","!":"!!","%24":"$","%28":"!(","(":"!(","%29":"!)",")":"!)","+":"!+","%2C":"!,",",":"!,","%3A":"!:",":":"!:","%3B":";"},J=40,I=41,T=44,M=58,q=38,_=48,$=65,B=97,Q=new Array(111);Q[33]="!",Q[40]="(",Q[41]=")",Q[43]="+",Q[44]=",",Q[45]=",",Q[48]="0",Q[49]="1",Q[50]="2",Q[51]="3",Q[52]="4",Q[53]="5",Q[54]="6",Q[55]="7",Q[56]="8",Q[57]="9",Q[58]=":",Q[116]="t",Q[102]="f",Q[110]="n";var K="",z=" ";function Z(e,t){var r=t?N:P,n=t?F:R;return encodeURIComponent(e).replace(r,(function(e){var t=n[e];return void 0===t?e:t}))}function G(e,t){switch(t){case _:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case $:case B:return 10;case 66:case 98:return 11;case 67:case 99:return 12;case 68:case 100:return 13;case 69:case 101:return 14;case 70:case 102:return 15;default:throw new SyntaxError(O(m,e))}}function H(e){if(e.coerceNullToEmptyString)return W(e,!1);if(e.impliedStringLiterals)throw new SyntaxError("JSON->URL: can not represent null with implied strings");return "null"}function W(e,t){if(t?e.allowEmptyUnquotedKeys:e.allowEmptyUnquotedValues)return K;if(e.AQF)return "!e";if(e.impliedStringLiterals)throw new SyntaxError(v);return "''"}Object.defineProperty(Array.prototype,"toJsonURLText",{value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=void 0;return this.forEach((function(n){if("function"==typeof n){if(!e.callFunctions)return;for(;"function"==typeof n;)n=n();}if(void 0===n){if(e.ignoreUndefinedArrayMembers)return;n=H(e);}else if(null===n){if(e.ignoreNullArrayMembers)return;n=H(e);}else n=n.toJsonURLText(e,t+1);void 0===r?r=n:!e.wwwFormUrlEncoded||t>0?r+=","+n:r+="&"+n;})),!e.isImplied||t>0?void 0===r?"()":"("+r+")":void 0===r?K:r}}),Object.defineProperty(Boolean.prototype,"toJsonURLText",{value:function(){return !0===this?"true":"false"}}),Object.defineProperty(Number.prototype,"toJsonURLText",{value:function(e){var t=String(this);return e.impliedStringLiterals&&-1!==t.indexOf("+")?Z(t,e):t}}),Object.defineProperty(Object.prototype,"toJsonURLText",{value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=void 0,n=Object.keys(this),i=this;return n.forEach((function(n){if(null!=n){var o=i[n];if("function"==typeof o){if(!e.callFunctions)return;for(;"function"==typeof o;)o=o();}if(void 0===o){if(e.ignoreUndefinedObjectMembers)return;o=H(e);}else if(null===o){if(e.ignoreNullObjectMembers)return;o=H(e);}else o=o.toJsonURLText(e,t+1);var s=n.toJsonURLText(e,t,!0);void 0===r?r=!e.wwwFormUrlEncoded||t>0?s+":"+o:s+"="+o:!e.wwwFormUrlEncoded||t>0?r+=","+s+":"+o:r+="&"+s+"="+o;}})),!e.isImplied||t>0?(e.noEmptyComposite&&void 0===r&&(r=":"),void 0===r?"()":"("+r+")"):void 0===r?K:r}}),Object.defineProperty(String.prototype,"toJsonURLText",{value:function(e,t,r){if(0===this.length)return W(e,r);if(e.impliedStringLiterals)return Z(this,e.AQF);if(D.test(this))return !0===r?this:e.AQF?"!"+this:-1==this.indexOf("+")?"'"+this+"'":encodeURIComponent(this);if(e.AQF)return Z(this,!0);if(C.test(this))return -1==this.indexOf(z)?this:this.replace(L,"+");if(j.test(this))return -1==this.indexOf(z)?"'"+this+"'":"'"+this.replace(L,"+")+"'";var n=Z(this);return 39==n.charCodeAt(0)?"%27"+n.substring(1):n}});var X=function(){function t(r,n,i,o){e(this,t),this.text=r,this.pos=this.markPos=n,this.end=i,this.options=o;}return r(t,[{key:"skipAmps",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0],t=this.text,r=this.end,n=this.pos;if(e)for(;n<r&&t.charCodeAt(n)===q;)n++;else if(n<r&&t.charCodeAt(n)===q){for(n++;n<r&&t.charCodeAt(n)===q;n++);n!==r&&n--;}this.pos=n;}},{key:"structChar",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.options.wwwFormUrlEncoded){var t=this.text.charCodeAt(this.pos);switch(t){case q:case 61:if(e)return;return this.pos++,t}}var r=this.pos,n=this.ordinal();switch(n){case T:case M:if(e)return void(this.pos=r);case J:case I:return n;default:return void(this.pos=r)}}},{key:"ordinal",value:function(e){return void 0!==e?this.text.charCodeAt(e):this.text.charCodeAt(this.pos++)}},{key:"accept",value:function(e){var t=this.pos;return this.ordinal()===e||(this.pos=t,!1)}},{key:"acceptPlus",value:function(){return 43==this.text.charCodeAt(this.pos)&&(this.pos++,!0)}},{key:"done",value:function(){return this.end<=this.pos}},{key:"validateLiteral",value:function(e,t){for(var r=this.text,n=this.end;e<n;e++){switch(g(r.charCodeAt(e))&t){case 0:throw new SyntaxError(O(h,e));case b:return e;case 8:return e+1;default:continue}}}},{key:"findLiteralEnd",value:function(){var e=this.text,t=this.end,r=this.pos,n=39===e.charCodeAt(r);n&&r++;var i=n?28:18;if(void 0!==(r=this.validateLiteral(r,i)))return r;if(n)throw new SyntaxError(O("JSON->URL: quoted string still open",r));return t}},{key:"isEmptyObject",value:function(){if(this.options.noEmptyComposite){var e=this.pos;if(!this.accept(M))return !1;var t=this.pos,r=this.accept(I);return this.pos=r?t:e,r}return !1}},{key:"parseLiteral",value:function(e){var t=this.pos,r=this.options,n=this.findLiteralEnd();if(void 0===e&&(e=this.ordinal(n)==M),n<=t)return function(e,t){if(t)return K;throw new SyntaxError(O(v,e))}(t,e?this.options.allowEmptyUnquotedKeys:this.options.allowEmptyUnquotedValues);if(!0===r.impliedStringLiterals)return this.parseStringLiteral(n,!0);var i=this.parseTrueFalseNull(n,e);if(void 0!==i)return i;var o=this.parseNumberLiteral(n,e);return void 0!==o?o:this.parseStringLiteral(n,!1)}},{key:"parseDigits",value:function(e){for(var t,r=!1;this.pos<e;)switch(this.ordinal()){case _:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:t=this.pos,r=!0;continue;default:return this.pos=t,r}return this.pos=t,r}},{key:"parseExponentValue",value:function(e){return !(e<=this.pos)&&(this.acceptPlus()||this.accept(45),this.parseDigits(e))}},{key:"parseExponent",value:function(e){var t=this.pos;switch(this.ordinal()){case 69:case 101:if(this.parseExponentValue(e))return !0}return this.pos=t,!1}},{key:"parseFraction",value:function(e){var t=this.pos;return !(e<=t)&&(!(!this.accept(46)||!this.parseDigits(e))||(this.pos=t,!1))}},{key:"parseInteger",value:function(e){return !(e<=this.pos)&&(!!this.accept(_)||this.parseDigits(e))}},{key:"parseNumberLiteral",value:function(e,t){var r=this.text,n=this.pos;if(this.accept(45),this.parseInteger(e)&&(this.parseFraction(e),this.parseExponent(e),this.pos===e)){var i=decodeURIComponent(r.substring(n,e));return t?i:Number(i)}this.pos=n;}},{key:"parseStringLiteral",value:function(e,t){var r=this.text,n=this.pos,i=t||39!==r.charCodeAt(n)?r.substring(n,e):r.substring(n+1,e-1);return i=decodeURIComponent(i.replace(k,z)),this.pos=e,i}},{key:"parseTrueFalseNull",value:function(e,t){var r,n,i,o,s,a=this.text,u=this.pos;switch(e-u){case 4:if(r=a.charCodeAt(u),n=a.charCodeAt(u+1),i=a.charCodeAt(u+2),o=a.charCodeAt(u+3),116===r&&114===n&&117===i&&101===o)return this.pos=e,!t||"true";if(110===r&&117===n&&108===i&&108===o)return this.pos=e,t?"null":this.newNullValue();break;case 5:if(r=a.charCodeAt(u),n=a.charCodeAt(u+1),i=a.charCodeAt(u+2),o=a.charCodeAt(u+3),s=a.charCodeAt(u+4),102===r&&n===B&&108===i&&115===o&&101===s)return this.pos=e,!!t&&"false"}}},{key:"newEmptyValue",value:function(){var e=this.options;if(e.noEmptyComposite)return [];var t=e.emptyValue;return "function"==typeof t?t():t}},{key:"newNullValue",value:function(){var e=this.options,t=e.nullValue;return "function"==typeof t&&(t=t()),null==t&&e.coerceNullToEmptyString&&(t=K),t}}]),t}(),Y=function(t){n(o,t);var i=p(o);function o(t,r,n,s){return e(this,o),i.call(this,t,r,n,s)}return r(o,[{key:"ordinal",value:function(e){var t,r,n=e||this.pos,i=this.text.charCodeAt(n);return 37===i?(t=function(e,t,r){if(r<=t+1)throw new SyntaxError(O(m,t));return G(t,e.charCodeAt(t))<<4|G(t,e.charCodeAt(t+1))}(this.text,n+1,this.end),r=3):(t=i,r=1),void 0===e&&(this.pos+=r),t}},{key:"acceptPlus",value:function(){return this.accept(43)}},{key:"findLiteralEnd",value:function(){for(var e=this.end,t=this.pos,r=this.text,n=t;;){if(e<=this.pos)return this.pos=t,e;switch(50&g(r.charCodeAt(this.pos))){case 48:if(this.options.wwwFormUrlEncoded)return n=this.pos,this.pos=t,n;case 0:throw new SyntaxError(O(h,n))}switch(this.ordinal()){case J:case I:case M:case T:return this.pos=t,n;case 33:if(this.pos===e)throw new SyntaxError(O(w,n));this.ordinal(),n=this.pos;break;default:n=this.pos;}}}},{key:"parseStringLiteral",value:function(e){var t=this.text,r=this.pos,n=decodeURIComponent(t.substring(r,e).replace(k,z));return this.pos=e,"!e"===n?K:n.replace(U,(function(e,t,n){if(2===e.length){var i=e.charCodeAt(1),o=Q[i];if(void 0!==o)return o}throw new SyntaxError(O(w,r+n))}))}}]),o}(X),ee=function(t){n(o,t);var i=p(o);function o(t){var r;return e(this,o),(r=i.call(this)).limits=t,r.parseDepth=0,r}return r(o,[{key:"replaceAndPush",value:function(e,t,r){if(this[this.parseDepth]=t,++this.parseDepth>=this.limits.maxParseDepth)throw new Error(O("JSON->URL: MaxParseDepth exceeded",e));this.push(r);}},{key:"replace",value:function(e){this[this.parseDepth]=e;}},{key:"depth",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return e&&(this.parseDepth--,this.pop()),this.parseDepth}}]),o}(u(Array)),te=function(t){n(o,t);var i=p(o);function o(t){var r;return e(this,o),(r=i.call(this)).limits=t,r.numValues=0,r}return r(o,[{key:"popObjectValue",value:function(e){e=e||this.pop();var t=this.pop(),r=this[this.length-1];return r[t]=e,r}},{key:"popArrayValue",value:function(e){e=e||this.pop();var t=this[this.length-1];return t.push(e),t}},{key:"checkValueLimit",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1;if(this.numValues+=t,this.numValues>this.limits.maxParseValues+1)throw new Error(O(y,e))}},{key:"appendArrayValue",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1;this.checkValueLimit(e,r),this.push(t);}}]),o}(u(Array));function re(e){for(;"function"==typeof e;)e=e();return e}function ne(e,t,r,n){return "number"==typeof e?"number"!=typeof t&&(r=t):r=e,(r=re(r))instanceof S||(r=new S(r,n)),r}function ie(e,t,r,n){return n.AQF?new Y(e,t,r,n):new X(e,t,r,n)}function oe(e,t){return "number"==typeof e?e:t}function se(e,t,r,n,i){if(void 0!==e){n=ne(t,r,n,i),e=String(e);var o=oe(t,0),s=oe(r,e.length);if(s<=o){if(void 0!==n.impliedArray)return n.impliedArray;if(void 0!==n.impliedObject)return n.impliedObject;throw new SyntaxError(O("JSON->URL: expected value",0))}if(s>n.maxParseChars)throw new Error("JSON->URL: MaxParseChars exceeded");var a=n.wwwFormUrlEncoded&&(n.impliedObject||n.impliedArray),u=new te(n),c=new ee(n),p=ie(e,o,s,n);if(void 0!==n.impliedObject)u.push(n.impliedObject),c.push(6);else if(void 0!==n.impliedArray)u.push(n.impliedArray),c.push(2);else {if(p.structChar(!0)!==J){var y=p.parseLiteral(!1);if(p.done())return y;throw new SyntaxError(O(l,0))}c.push(1);}for(a&&p.skipAmps(!0);;){if(p.done())throw new SyntaxError(O(f,p.pos));var v=void 0,w=void 0,m=void 0;switch(c[c.depth()]){case 1:switch(p.structChar(!0)){case J:u.appendArrayValue(p.pos,[]),c.replaceAndPush(p.pos,3,1);continue;case I:if(-1===c.depth(!0)){if(p.done())return p.newEmptyValue();throw new SyntaxError(O(d,p.pos))}if(u.appendArrayValue(p.pos,p.newEmptyValue()),0===c.depth()&&(a&&p.skipAmps(),p.done())){if(n.impliedArray)return u.popArrayValue();if(n.impliedObject)return u.popObjectValue();throw new SyntaxError(O(f,p.pos))}continue}switch(u.checkValueLimit(p.pos),v=(w=p.isEmptyObject())?{}:p.parseLiteral(),m=p.pos,p.structChar()){case q:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,m));case T:c.replace(2),u.appendArrayValue(m,[]),u.push(v),u.popArrayValue();continue;case I:switch(w?u.push({}):u.appendArrayValue(m,[v]),c.depth(!0)){case-1:if(p.pos===s)return u[0];throw new SyntaxError(O(d,m));case 0:if(a&&p.skipAmps(),p.done()){if(n.impliedArray)return u.popArrayValue();if(n.impliedObject)return u.popObjectValue();throw new SyntaxError(O(f,m))}}continue;case 61:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,m));case M:c.replace(4),u.push({},v);continue;default:throw new SyntaxError(O(l,m))}case 2:if(p.accept(J)){c.replaceAndPush(p.pos,3,1);continue}if(u.checkValueLimit(p.pos),v=p.parseLiteral(!1),a&&p.skipAmps(),p.done()){if(0===c.depth()&&n.impliedArray)return u.popArrayValue(v);throw new SyntaxError(O(f,s))}c.replace(3),u.push(v);continue;case 3:switch(u.popArrayValue(),p.structChar()){case q:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,p.pos));case T:c.replace(2);continue;case I:switch(c.depth(!0)){case-1:if(p.done()&&!n.impliedArray)return u[0];throw new SyntaxError(O(d,p.pos));case 0:if(a&&p.skipAmps(),p.done()){if(n.impliedArray)return u.popArrayValue();if(n.impliedObject)return u.popObjectValue();throw new SyntaxError(O(f,p.pos))}}continue}throw new SyntaxError(O("JSON->URL: expected comma or close paren",p.pos));case 4:if(p.accept(J)){c.replaceAndPush(p.pos,5,1);continue}if(u.checkValueLimit(p.pos),v=p.parseLiteral(!1),a&&p.skipAmps(),p.done()){if(0===c.depth()&&n.impliedObject)return u.popObjectValue(v);throw new SyntaxError(O(f,s))}c.replace(5),u.push(v);continue;case 5:switch(u.popObjectValue(),m=p.pos,p.structChar()){case q:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,m));case T:c.replace(6);continue;case I:switch(c.depth(!0)){case-1:if(p.done()&&!n.impliedObject)return u[0];throw new SyntaxError(O(d,p.pos));case 0:if(a&&p.skipAmps(),p.done()){if(n.impliedArray)return u.popArrayValue();if(n.impliedObject)return u.popObjectValue();throw new SyntaxError(O(d,p.pos))}}continue}throw new SyntaxError(O("JSON->URL: expected comma, open paren, or close paren",p.pos));case 6:if(v=p.parseLiteral(!0),a&&p.skipAmps(),p.done()){if(n.impliedObject&&0==c.depth())return u.push(v,n.getMissingValue(v)),u.popObjectValue();throw new SyntaxError(O(f,s))}switch(p.structChar()){case 61:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,p.pos));case M:break;case q:if(!n.wwwFormUrlEncoded||c.depth()>0)throw new SyntaxError(O(h,p.pos));case T:if(n.impliedObject&&0==c.depth()){u.push(v,n.getMissingValue(v)),u.popObjectValue();continue}default:throw new SyntaxError(O(x,p.pos))}c.replace(4),u.push(v);continue;default:throw new SyntaxError(O("JSON->URL: internal error",p.pos))}}}}return function(){function t(r){for(e(this,t);"function"==typeof r;)r=r();void 0===r&&(r={}),this.maxParseDepth="number"==typeof r.maxParseDepth?parseInt(r.maxParseDepth):32,this.maxParseValues="number"==typeof r.maxParseValues?parseInt(r.maxParseValues):4096,this.maxParseChars="number"==typeof r.maxParseChars?parseInt(r.maxParseChars):32768,this.emptyValue=void 0===r.emptyValue?{}:r.emptyValue,this.nullValue=void 0===r.nullValue?null:r.nullValue;}return r(t,[{key:"parseLiteral",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4?arguments[4]:void 0;void 0!==e&&(e=String(e)),void 0===r&&(r=e.length);var o=ie(e,t,r,ne(i));return o.parseLiteral(n)}},{key:"parse",value:function(e,t,r,n){return se(e,t,r,n,this)}}],[{key:"parse",value:function(e,t,r,n){return se(e,t,r,n,void 0)}},{key:"stringify",value:function(e,t){if(void 0!==e)return t=new V(re(t)),null===e?H(t):e.toJsonURLText(t,0)}}]),t}()}));
    }(jsonurl_min));

    var JsonURL = jsonurl_min.exports;

    var queryString = {};

    var strictUriEncode = str => encodeURIComponent(str).replace(/[!'()*]/g, x => `%${x.charCodeAt(0).toString(16).toUpperCase()}`);

    var token = '%[a-f0-9]{2}';
    var singleMatcher = new RegExp(token, 'gi');
    var multiMatcher = new RegExp('(' + token + ')+', 'gi');

    function decodeComponents(components, split) {
    	try {
    		// Try to decode the entire string first
    		return decodeURIComponent(components.join(''));
    	} catch (err) {
    		// Do nothing
    	}

    	if (components.length === 1) {
    		return components;
    	}

    	split = split || 1;

    	// Split the array in 2 parts
    	var left = components.slice(0, split);
    	var right = components.slice(split);

    	return Array.prototype.concat.call([], decodeComponents(left), decodeComponents(right));
    }

    function decode$1(input) {
    	try {
    		return decodeURIComponent(input);
    	} catch (err) {
    		var tokens = input.match(singleMatcher);

    		for (var i = 1; i < tokens.length; i++) {
    			input = decodeComponents(tokens, i).join('');

    			tokens = input.match(singleMatcher);
    		}

    		return input;
    	}
    }

    function customDecodeURIComponent(input) {
    	// Keep track of all the replacements and prefill the map with the `BOM`
    	var replaceMap = {
    		'%FE%FF': '\uFFFD\uFFFD',
    		'%FF%FE': '\uFFFD\uFFFD'
    	};

    	var match = multiMatcher.exec(input);
    	while (match) {
    		try {
    			// Decode as big chunks as possible
    			replaceMap[match[0]] = decodeURIComponent(match[0]);
    		} catch (err) {
    			var result = decode$1(match[0]);

    			if (result !== match[0]) {
    				replaceMap[match[0]] = result;
    			}
    		}

    		match = multiMatcher.exec(input);
    	}

    	// Add `%C2` at the end of the map to make sure it does not replace the combinator before everything else
    	replaceMap['%C2'] = '\uFFFD';

    	var entries = Object.keys(replaceMap);

    	for (var i = 0; i < entries.length; i++) {
    		// Replace all decoded components
    		var key = entries[i];
    		input = input.replace(new RegExp(key, 'g'), replaceMap[key]);
    	}

    	return input;
    }

    var decodeUriComponent = function (encodedURI) {
    	if (typeof encodedURI !== 'string') {
    		throw new TypeError('Expected `encodedURI` to be of type `string`, got `' + typeof encodedURI + '`');
    	}

    	try {
    		encodedURI = encodedURI.replace(/\+/g, ' ');

    		// Try the built in decoder first
    		return decodeURIComponent(encodedURI);
    	} catch (err) {
    		// Fallback to a more advanced decoder
    		return customDecodeURIComponent(encodedURI);
    	}
    };

    var splitOnFirst = (string, separator) => {
    	if (!(typeof string === 'string' && typeof separator === 'string')) {
    		throw new TypeError('Expected the arguments to be of type `string`');
    	}

    	if (separator === '') {
    		return [string];
    	}

    	const separatorIndex = string.indexOf(separator);

    	if (separatorIndex === -1) {
    		return [string];
    	}

    	return [
    		string.slice(0, separatorIndex),
    		string.slice(separatorIndex + separator.length)
    	];
    };

    var filterObj = function (obj, predicate) {
    	var ret = {};
    	var keys = Object.keys(obj);
    	var isArr = Array.isArray(predicate);

    	for (var i = 0; i < keys.length; i++) {
    		var key = keys[i];
    		var val = obj[key];

    		if (isArr ? predicate.indexOf(key) !== -1 : predicate(key, val, obj)) {
    			ret[key] = val;
    		}
    	}

    	return ret;
    };

    (function (exports) {
    const strictUriEncode$1 = strictUriEncode;
    const decodeComponent = decodeUriComponent;
    const splitOnFirst$1 = splitOnFirst;
    const filterObject = filterObj;

    const isNullOrUndefined = value => value === null || value === undefined;

    function encoderForArrayFormat(options) {
    	switch (options.arrayFormat) {
    		case 'index':
    			return key => (result, value) => {
    				const index = result.length;

    				if (
    					value === undefined ||
    					(options.skipNull && value === null) ||
    					(options.skipEmptyString && value === '')
    				) {
    					return result;
    				}

    				if (value === null) {
    					return [...result, [encode(key, options), '[', index, ']'].join('')];
    				}

    				return [
    					...result,
    					[encode(key, options), '[', encode(index, options), ']=', encode(value, options)].join('')
    				];
    			};

    		case 'bracket':
    			return key => (result, value) => {
    				if (
    					value === undefined ||
    					(options.skipNull && value === null) ||
    					(options.skipEmptyString && value === '')
    				) {
    					return result;
    				}

    				if (value === null) {
    					return [...result, [encode(key, options), '[]'].join('')];
    				}

    				return [...result, [encode(key, options), '[]=', encode(value, options)].join('')];
    			};

    		case 'comma':
    		case 'separator':
    			return key => (result, value) => {
    				if (value === null || value === undefined || value.length === 0) {
    					return result;
    				}

    				if (result.length === 0) {
    					return [[encode(key, options), '=', encode(value, options)].join('')];
    				}

    				return [[result, encode(value, options)].join(options.arrayFormatSeparator)];
    			};

    		default:
    			return key => (result, value) => {
    				if (
    					value === undefined ||
    					(options.skipNull && value === null) ||
    					(options.skipEmptyString && value === '')
    				) {
    					return result;
    				}

    				if (value === null) {
    					return [...result, encode(key, options)];
    				}

    				return [...result, [encode(key, options), '=', encode(value, options)].join('')];
    			};
    	}
    }

    function parserForArrayFormat(options) {
    	let result;

    	switch (options.arrayFormat) {
    		case 'index':
    			return (key, value, accumulator) => {
    				result = /\[(\d*)\]$/.exec(key);

    				key = key.replace(/\[\d*\]$/, '');

    				if (!result) {
    					accumulator[key] = value;
    					return;
    				}

    				if (accumulator[key] === undefined) {
    					accumulator[key] = {};
    				}

    				accumulator[key][result[1]] = value;
    			};

    		case 'bracket':
    			return (key, value, accumulator) => {
    				result = /(\[\])$/.exec(key);
    				key = key.replace(/\[\]$/, '');

    				if (!result) {
    					accumulator[key] = value;
    					return;
    				}

    				if (accumulator[key] === undefined) {
    					accumulator[key] = [value];
    					return;
    				}

    				accumulator[key] = [].concat(accumulator[key], value);
    			};

    		case 'comma':
    		case 'separator':
    			return (key, value, accumulator) => {
    				const isArray = typeof value === 'string' && value.includes(options.arrayFormatSeparator);
    				const isEncodedArray = (typeof value === 'string' && !isArray && decode(value, options).includes(options.arrayFormatSeparator));
    				value = isEncodedArray ? decode(value, options) : value;
    				const newValue = isArray || isEncodedArray ? value.split(options.arrayFormatSeparator).map(item => decode(item, options)) : value === null ? value : decode(value, options);
    				accumulator[key] = newValue;
    			};

    		default:
    			return (key, value, accumulator) => {
    				if (accumulator[key] === undefined) {
    					accumulator[key] = value;
    					return;
    				}

    				accumulator[key] = [].concat(accumulator[key], value);
    			};
    	}
    }

    function validateArrayFormatSeparator(value) {
    	if (typeof value !== 'string' || value.length !== 1) {
    		throw new TypeError('arrayFormatSeparator must be single character string');
    	}
    }

    function encode(value, options) {
    	if (options.encode) {
    		return options.strict ? strictUriEncode$1(value) : encodeURIComponent(value);
    	}

    	return value;
    }

    function decode(value, options) {
    	if (options.decode) {
    		return decodeComponent(value);
    	}

    	return value;
    }

    function keysSorter(input) {
    	if (Array.isArray(input)) {
    		return input.sort();
    	}

    	if (typeof input === 'object') {
    		return keysSorter(Object.keys(input))
    			.sort((a, b) => Number(a) - Number(b))
    			.map(key => input[key]);
    	}

    	return input;
    }

    function removeHash(input) {
    	const hashStart = input.indexOf('#');
    	if (hashStart !== -1) {
    		input = input.slice(0, hashStart);
    	}

    	return input;
    }

    function getHash(url) {
    	let hash = '';
    	const hashStart = url.indexOf('#');
    	if (hashStart !== -1) {
    		hash = url.slice(hashStart);
    	}

    	return hash;
    }

    function extract(input) {
    	input = removeHash(input);
    	const queryStart = input.indexOf('?');
    	if (queryStart === -1) {
    		return '';
    	}

    	return input.slice(queryStart + 1);
    }

    function parseValue(value, options) {
    	if (options.parseNumbers && !Number.isNaN(Number(value)) && (typeof value === 'string' && value.trim() !== '')) {
    		value = Number(value);
    	} else if (options.parseBooleans && value !== null && (value.toLowerCase() === 'true' || value.toLowerCase() === 'false')) {
    		value = value.toLowerCase() === 'true';
    	}

    	return value;
    }

    function parse(query, options) {
    	options = Object.assign({
    		decode: true,
    		sort: true,
    		arrayFormat: 'none',
    		arrayFormatSeparator: ',',
    		parseNumbers: false,
    		parseBooleans: false
    	}, options);

    	validateArrayFormatSeparator(options.arrayFormatSeparator);

    	const formatter = parserForArrayFormat(options);

    	// Create an object with no prototype
    	const ret = Object.create(null);

    	if (typeof query !== 'string') {
    		return ret;
    	}

    	query = query.trim().replace(/^[?#&]/, '');

    	if (!query) {
    		return ret;
    	}

    	for (const param of query.split('&')) {
    		if (param === '') {
    			continue;
    		}

    		let [key, value] = splitOnFirst$1(options.decode ? param.replace(/\+/g, ' ') : param, '=');

    		// Missing `=` should be `null`:
    		// http://w3.org/TR/2012/WD-url-20120524/#collect-url-parameters
    		value = value === undefined ? null : ['comma', 'separator'].includes(options.arrayFormat) ? value : decode(value, options);
    		formatter(decode(key, options), value, ret);
    	}

    	for (const key of Object.keys(ret)) {
    		const value = ret[key];
    		if (typeof value === 'object' && value !== null) {
    			for (const k of Object.keys(value)) {
    				value[k] = parseValue(value[k], options);
    			}
    		} else {
    			ret[key] = parseValue(value, options);
    		}
    	}

    	if (options.sort === false) {
    		return ret;
    	}

    	return (options.sort === true ? Object.keys(ret).sort() : Object.keys(ret).sort(options.sort)).reduce((result, key) => {
    		const value = ret[key];
    		if (Boolean(value) && typeof value === 'object' && !Array.isArray(value)) {
    			// Sort object keys, not values
    			result[key] = keysSorter(value);
    		} else {
    			result[key] = value;
    		}

    		return result;
    	}, Object.create(null));
    }

    exports.extract = extract;
    exports.parse = parse;

    exports.stringify = (object, options) => {
    	if (!object) {
    		return '';
    	}

    	options = Object.assign({
    		encode: true,
    		strict: true,
    		arrayFormat: 'none',
    		arrayFormatSeparator: ','
    	}, options);

    	validateArrayFormatSeparator(options.arrayFormatSeparator);

    	const shouldFilter = key => (
    		(options.skipNull && isNullOrUndefined(object[key])) ||
    		(options.skipEmptyString && object[key] === '')
    	);

    	const formatter = encoderForArrayFormat(options);

    	const objectCopy = {};

    	for (const key of Object.keys(object)) {
    		if (!shouldFilter(key)) {
    			objectCopy[key] = object[key];
    		}
    	}

    	const keys = Object.keys(objectCopy);

    	if (options.sort !== false) {
    		keys.sort(options.sort);
    	}

    	return keys.map(key => {
    		const value = object[key];

    		if (value === undefined) {
    			return '';
    		}

    		if (value === null) {
    			return encode(key, options);
    		}

    		if (Array.isArray(value)) {
    			return value
    				.reduce(formatter(key), [])
    				.join('&');
    		}

    		return encode(key, options) + '=' + encode(value, options);
    	}).filter(x => x.length > 0).join('&');
    };

    exports.parseUrl = (url, options) => {
    	options = Object.assign({
    		decode: true
    	}, options);

    	const [url_, hash] = splitOnFirst$1(url, '#');

    	return Object.assign(
    		{
    			url: url_.split('?')[0] || '',
    			query: parse(extract(url), options)
    		},
    		options && options.parseFragmentIdentifier && hash ? {fragmentIdentifier: decode(hash, options)} : {}
    	);
    };

    exports.stringifyUrl = (object, options) => {
    	options = Object.assign({
    		encode: true,
    		strict: true
    	}, options);

    	const url = removeHash(object.url).split('?')[0] || '';
    	const queryFromUrl = exports.extract(object.url);
    	const parsedQueryFromUrl = exports.parse(queryFromUrl, {sort: false});

    	const query = Object.assign(parsedQueryFromUrl, object.query);
    	let queryString = exports.stringify(query, options);
    	if (queryString) {
    		queryString = `?${queryString}`;
    	}

    	let hash = getHash(object.url);
    	if (object.fragmentIdentifier) {
    		hash = `#${encode(object.fragmentIdentifier, options)}`;
    	}

    	return `${url}${queryString}${hash}`;
    };

    exports.pick = (input, filter, options) => {
    	options = Object.assign({
    		parseFragmentIdentifier: true
    	}, options);

    	const {url, query, fragmentIdentifier} = exports.parseUrl(input, options);
    	return exports.stringifyUrl({
    		url,
    		query: filterObject(query, filter),
    		fragmentIdentifier
    	}, options);
    };

    exports.exclude = (input, filter, options) => {
    	const exclusionFilter = Array.isArray(filter) ? key => !filter.includes(key) : (key, value) => !filter(key, value);

    	return exports.pick(input, exclusionFilter, options);
    };
    }(queryString));

    /**
     * Check if we're required to add a port number.
     *
     * @see https://url.spec.whatwg.org/#default-port
     * @param {Number|String} port Port number we need to check
     * @param {String} protocol Protocol we need to check against.
     * @returns {Boolean} Is it a default port for the given protocol
     * @api private
     */
    var requiresPort = function required(port, protocol) {
      protocol = protocol.split(':')[0];
      port = +port;

      if (!port) return false;

      switch (protocol) {
        case 'http':
        case 'ws':
        return port !== 80;

        case 'https':
        case 'wss':
        return port !== 443;

        case 'ftp':
        return port !== 21;

        case 'gopher':
        return port !== 70;

        case 'file':
        return false;
      }

      return port !== 0;
    };

    var querystringify$1 = {};

    var has = Object.prototype.hasOwnProperty
      , undef;

    /**
     * Decode a URI encoded string.
     *
     * @param {String} input The URI encoded string.
     * @returns {String|Null} The decoded string.
     * @api private
     */
    function decode(input) {
      try {
        return decodeURIComponent(input.replace(/\+/g, ' '));
      } catch (e) {
        return null;
      }
    }

    /**
     * Attempts to encode a given input.
     *
     * @param {String} input The string that needs to be encoded.
     * @returns {String|Null} The encoded string.
     * @api private
     */
    function encode(input) {
      try {
        return encodeURIComponent(input);
      } catch (e) {
        return null;
      }
    }

    /**
     * Simple query string parser.
     *
     * @param {String} query The query string that needs to be parsed.
     * @returns {Object}
     * @api public
     */
    function querystring(query) {
      var parser = /([^=?#&]+)=?([^&]*)/g
        , result = {}
        , part;

      while (part = parser.exec(query)) {
        var key = decode(part[1])
          , value = decode(part[2]);

        //
        // Prevent overriding of existing properties. This ensures that build-in
        // methods like `toString` or __proto__ are not overriden by malicious
        // querystrings.
        //
        // In the case if failed decoding, we want to omit the key/value pairs
        // from the result.
        //
        if (key === null || value === null || key in result) continue;
        result[key] = value;
      }

      return result;
    }

    /**
     * Transform a query string to an object.
     *
     * @param {Object} obj Object that should be transformed.
     * @param {String} prefix Optional prefix.
     * @returns {String}
     * @api public
     */
    function querystringify(obj, prefix) {
      prefix = prefix || '';

      var pairs = []
        , value
        , key;

      //
      // Optionally prefix with a '?' if needed
      //
      if ('string' !== typeof prefix) prefix = '?';

      for (key in obj) {
        if (has.call(obj, key)) {
          value = obj[key];

          //
          // Edge cases where we actually want to encode the value to an empty
          // string instead of the stringified value.
          //
          if (!value && (value === null || value === undef || isNaN(value))) {
            value = '';
          }

          key = encode(key);
          value = encode(value);

          //
          // If we failed to encode the strings, we should bail out as we don't
          // want to add invalid strings to the query.
          //
          if (key === null || value === null) continue;
          pairs.push(key +'='+ value);
        }
      }

      return pairs.length ? prefix + pairs.join('&') : '';
    }

    //
    // Expose the module.
    //
    querystringify$1.stringify = querystringify;
    querystringify$1.parse = querystring;

    var required = requiresPort
      , qs = querystringify$1
      , slashes = /^[A-Za-z][A-Za-z0-9+-.]*:\/\//
      , protocolre = /^([a-z][a-z0-9.+-]*:)?(\/\/)?([\\/]+)?([\S\s]*)/i
      , windowsDriveLetter = /^[a-zA-Z]:/
      , whitespace = '[\\x09\\x0A\\x0B\\x0C\\x0D\\x20\\xA0\\u1680\\u180E\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200A\\u202F\\u205F\\u3000\\u2028\\u2029\\uFEFF]'
      , left = new RegExp('^'+ whitespace +'+');

    /**
     * Trim a given string.
     *
     * @param {String} str String to trim.
     * @public
     */
    function trimLeft(str) {
      return (str ? str : '').toString().replace(left, '');
    }

    /**
     * These are the parse rules for the URL parser, it informs the parser
     * about:
     *
     * 0. The char it Needs to parse, if it's a string it should be done using
     *    indexOf, RegExp using exec and NaN means set as current value.
     * 1. The property we should set when parsing this value.
     * 2. Indication if it's backwards or forward parsing, when set as number it's
     *    the value of extra chars that should be split off.
     * 3. Inherit from location if non existing in the parser.
     * 4. `toLowerCase` the resulting value.
     */
    var rules = [
      ['#', 'hash'],                        // Extract from the back.
      ['?', 'query'],                       // Extract from the back.
      function sanitize(address, url) {     // Sanitize what is left of the address
        return isSpecial(url.protocol) ? address.replace(/\\/g, '/') : address;
      },
      ['/', 'pathname'],                    // Extract from the back.
      ['@', 'auth', 1],                     // Extract from the front.
      [NaN, 'host', undefined, 1, 1],       // Set left over value.
      [/:(\d+)$/, 'port', undefined, 1],    // RegExp the back.
      [NaN, 'hostname', undefined, 1, 1]    // Set left over.
    ];

    /**
     * These properties should not be copied or inherited from. This is only needed
     * for all non blob URL's as a blob URL does not include a hash, only the
     * origin.
     *
     * @type {Object}
     * @private
     */
    var ignore = { hash: 1, query: 1 };

    /**
     * The location object differs when your code is loaded through a normal page,
     * Worker or through a worker using a blob. And with the blobble begins the
     * trouble as the location object will contain the URL of the blob, not the
     * location of the page where our code is loaded in. The actual origin is
     * encoded in the `pathname` so we can thankfully generate a good "default"
     * location from it so we can generate proper relative URL's again.
     *
     * @param {Object|String} loc Optional default location object.
     * @returns {Object} lolcation object.
     * @public
     */
    function lolcation(loc) {
      var globalVar;

      if (typeof window !== 'undefined') globalVar = window;
      else if (typeof commonjsGlobal !== 'undefined') globalVar = commonjsGlobal;
      else if (typeof self !== 'undefined') globalVar = self;
      else globalVar = {};

      var location = globalVar.location || {};
      loc = loc || location;

      var finaldestination = {}
        , type = typeof loc
        , key;

      if ('blob:' === loc.protocol) {
        finaldestination = new Url(unescape(loc.pathname), {});
      } else if ('string' === type) {
        finaldestination = new Url(loc, {});
        for (key in ignore) delete finaldestination[key];
      } else if ('object' === type) {
        for (key in loc) {
          if (key in ignore) continue;
          finaldestination[key] = loc[key];
        }

        if (finaldestination.slashes === undefined) {
          finaldestination.slashes = slashes.test(loc.href);
        }
      }

      return finaldestination;
    }

    /**
     * Check whether a protocol scheme is special.
     *
     * @param {String} The protocol scheme of the URL
     * @return {Boolean} `true` if the protocol scheme is special, else `false`
     * @private
     */
    function isSpecial(scheme) {
      return (
        scheme === 'file:' ||
        scheme === 'ftp:' ||
        scheme === 'http:' ||
        scheme === 'https:' ||
        scheme === 'ws:' ||
        scheme === 'wss:'
      );
    }

    /**
     * @typedef ProtocolExtract
     * @type Object
     * @property {String} protocol Protocol matched in the URL, in lowercase.
     * @property {Boolean} slashes `true` if protocol is followed by "//", else `false`.
     * @property {String} rest Rest of the URL that is not part of the protocol.
     */

    /**
     * Extract protocol information from a URL with/without double slash ("//").
     *
     * @param {String} address URL we want to extract from.
     * @param {Object} location
     * @return {ProtocolExtract} Extracted information.
     * @private
     */
    function extractProtocol(address, location) {
      address = trimLeft(address);
      location = location || {};

      var match = protocolre.exec(address);
      var protocol = match[1] ? match[1].toLowerCase() : '';
      var forwardSlashes = !!match[2];
      var otherSlashes = !!match[3];
      var slashesCount = 0;
      var rest;

      if (forwardSlashes) {
        if (otherSlashes) {
          rest = match[2] + match[3] + match[4];
          slashesCount = match[2].length + match[3].length;
        } else {
          rest = match[2] + match[4];
          slashesCount = match[2].length;
        }
      } else {
        if (otherSlashes) {
          rest = match[3] + match[4];
          slashesCount = match[3].length;
        } else {
          rest = match[4];
        }
      }

      if (protocol === 'file:') {
        if (slashesCount >= 2) {
          rest = rest.slice(2);
        }
      } else if (isSpecial(protocol)) {
        rest = match[4];
      } else if (protocol) {
        if (forwardSlashes) {
          rest = rest.slice(2);
        }
      } else if (slashesCount >= 2 && isSpecial(location.protocol)) {
        rest = match[4];
      }

      return {
        protocol: protocol,
        slashes: forwardSlashes || isSpecial(protocol),
        slashesCount: slashesCount,
        rest: rest
      };
    }

    /**
     * Resolve a relative URL pathname against a base URL pathname.
     *
     * @param {String} relative Pathname of the relative URL.
     * @param {String} base Pathname of the base URL.
     * @return {String} Resolved pathname.
     * @private
     */
    function resolve(relative, base) {
      if (relative === '') return base;

      var path = (base || '/').split('/').slice(0, -1).concat(relative.split('/'))
        , i = path.length
        , last = path[i - 1]
        , unshift = false
        , up = 0;

      while (i--) {
        if (path[i] === '.') {
          path.splice(i, 1);
        } else if (path[i] === '..') {
          path.splice(i, 1);
          up++;
        } else if (up) {
          if (i === 0) unshift = true;
          path.splice(i, 1);
          up--;
        }
      }

      if (unshift) path.unshift('');
      if (last === '.' || last === '..') path.push('');

      return path.join('/');
    }

    /**
     * The actual URL instance. Instead of returning an object we've opted-in to
     * create an actual constructor as it's much more memory efficient and
     * faster and it pleases my OCD.
     *
     * It is worth noting that we should not use `URL` as class name to prevent
     * clashes with the global URL instance that got introduced in browsers.
     *
     * @constructor
     * @param {String} address URL we want to parse.
     * @param {Object|String} [location] Location defaults for relative paths.
     * @param {Boolean|Function} [parser] Parser for the query string.
     * @private
     */
    function Url(address, location, parser) {
      address = trimLeft(address);

      if (!(this instanceof Url)) {
        return new Url(address, location, parser);
      }

      var relative, extracted, parse, instruction, index, key
        , instructions = rules.slice()
        , type = typeof location
        , url = this
        , i = 0;

      //
      // The following if statements allows this module two have compatibility with
      // 2 different API:
      //
      // 1. Node.js's `url.parse` api which accepts a URL, boolean as arguments
      //    where the boolean indicates that the query string should also be parsed.
      //
      // 2. The `URL` interface of the browser which accepts a URL, object as
      //    arguments. The supplied object will be used as default values / fall-back
      //    for relative paths.
      //
      if ('object' !== type && 'string' !== type) {
        parser = location;
        location = null;
      }

      if (parser && 'function' !== typeof parser) parser = qs.parse;

      location = lolcation(location);

      //
      // Extract protocol information before running the instructions.
      //
      extracted = extractProtocol(address || '', location);
      relative = !extracted.protocol && !extracted.slashes;
      url.slashes = extracted.slashes || relative && location.slashes;
      url.protocol = extracted.protocol || location.protocol || '';
      address = extracted.rest;

      //
      // When the authority component is absent the URL starts with a path
      // component.
      //
      if (
        extracted.protocol === 'file:' && (
          extracted.slashesCount !== 2 || windowsDriveLetter.test(address)) ||
        (!extracted.slashes &&
          (extracted.protocol ||
            extracted.slashesCount < 2 ||
            !isSpecial(url.protocol)))
      ) {
        instructions[3] = [/(.*)/, 'pathname'];
      }

      for (; i < instructions.length; i++) {
        instruction = instructions[i];

        if (typeof instruction === 'function') {
          address = instruction(address, url);
          continue;
        }

        parse = instruction[0];
        key = instruction[1];

        if (parse !== parse) {
          url[key] = address;
        } else if ('string' === typeof parse) {
          if (~(index = address.indexOf(parse))) {
            if ('number' === typeof instruction[2]) {
              url[key] = address.slice(0, index);
              address = address.slice(index + instruction[2]);
            } else {
              url[key] = address.slice(index);
              address = address.slice(0, index);
            }
          }
        } else if ((index = parse.exec(address))) {
          url[key] = index[1];
          address = address.slice(0, index.index);
        }

        url[key] = url[key] || (
          relative && instruction[3] ? location[key] || '' : ''
        );

        //
        // Hostname, host and protocol should be lowercased so they can be used to
        // create a proper `origin`.
        //
        if (instruction[4]) url[key] = url[key].toLowerCase();
      }

      //
      // Also parse the supplied query string in to an object. If we're supplied
      // with a custom parser as function use that instead of the default build-in
      // parser.
      //
      if (parser) url.query = parser(url.query);

      //
      // If the URL is relative, resolve the pathname against the base URL.
      //
      if (
          relative
        && location.slashes
        && url.pathname.charAt(0) !== '/'
        && (url.pathname !== '' || location.pathname !== '')
      ) {
        url.pathname = resolve(url.pathname, location.pathname);
      }

      //
      // Default to a / for pathname if none exists. This normalizes the URL
      // to always have a /
      //
      if (url.pathname.charAt(0) !== '/' && isSpecial(url.protocol)) {
        url.pathname = '/' + url.pathname;
      }

      //
      // We should not add port numbers if they are already the default port number
      // for a given protocol. As the host also contains the port number we're going
      // override it with the hostname which contains no port number.
      //
      if (!required(url.port, url.protocol)) {
        url.host = url.hostname;
        url.port = '';
      }

      //
      // Parse down the `auth` for the username and password.
      //
      url.username = url.password = '';
      if (url.auth) {
        instruction = url.auth.split(':');
        url.username = instruction[0] || '';
        url.password = instruction[1] || '';
      }

      url.origin = url.protocol !== 'file:' && isSpecial(url.protocol) && url.host
        ? url.protocol +'//'+ url.host
        : 'null';

      //
      // The href is just the compiled result.
      //
      url.href = url.toString();
    }

    /**
     * This is convenience method for changing properties in the URL instance to
     * insure that they all propagate correctly.
     *
     * @param {String} part          Property we need to adjust.
     * @param {Mixed} value          The newly assigned value.
     * @param {Boolean|Function} fn  When setting the query, it will be the function
     *                               used to parse the query.
     *                               When setting the protocol, double slash will be
     *                               removed from the final url if it is true.
     * @returns {URL} URL instance for chaining.
     * @public
     */
    function set(part, value, fn) {
      var url = this;

      switch (part) {
        case 'query':
          if ('string' === typeof value && value.length) {
            value = (fn || qs.parse)(value);
          }

          url[part] = value;
          break;

        case 'port':
          url[part] = value;

          if (!required(value, url.protocol)) {
            url.host = url.hostname;
            url[part] = '';
          } else if (value) {
            url.host = url.hostname +':'+ value;
          }

          break;

        case 'hostname':
          url[part] = value;

          if (url.port) value += ':'+ url.port;
          url.host = value;
          break;

        case 'host':
          url[part] = value;

          if (/:\d+$/.test(value)) {
            value = value.split(':');
            url.port = value.pop();
            url.hostname = value.join(':');
          } else {
            url.hostname = value;
            url.port = '';
          }

          break;

        case 'protocol':
          url.protocol = value.toLowerCase();
          url.slashes = !fn;
          break;

        case 'pathname':
        case 'hash':
          if (value) {
            var char = part === 'pathname' ? '/' : '#';
            url[part] = value.charAt(0) !== char ? char + value : value;
          } else {
            url[part] = value;
          }
          break;

        default:
          url[part] = value;
      }

      for (var i = 0; i < rules.length; i++) {
        var ins = rules[i];

        if (ins[4]) url[ins[1]] = url[ins[1]].toLowerCase();
      }

      url.origin = url.protocol !== 'file:' && isSpecial(url.protocol) && url.host
        ? url.protocol +'//'+ url.host
        : 'null';

      url.href = url.toString();

      return url;
    }

    /**
     * Transform the properties back in to a valid and full URL string.
     *
     * @param {Function} stringify Optional query stringify function.
     * @returns {String} Compiled version of the URL.
     * @public
     */
    function toString(stringify) {
      if (!stringify || 'function' !== typeof stringify) stringify = qs.stringify;

      var query
        , url = this
        , protocol = url.protocol;

      if (protocol && protocol.charAt(protocol.length - 1) !== ':') protocol += ':';

      var result = protocol + (url.slashes || isSpecial(url.protocol) ? '//' : '');

      if (url.username) {
        result += url.username;
        if (url.password) result += ':'+ url.password;
        result += '@';
      }

      result += url.host + url.pathname;

      query = 'object' === typeof url.query ? stringify(url.query) : url.query;
      if (query) result += '?' !== query.charAt(0) ? '?'+ query : query;

      if (url.hash) result += url.hash;

      return result;
    }

    Url.prototype = { set: set, toString: toString };

    //
    // Expose the URL parser and some additional properties that might be useful for
    // others or testing.
    //
    Url.extractProtocol = extractProtocol;
    Url.location = lolcation;
    Url.trimLeft = trimLeft;
    Url.qs = qs;

    var urlParse = Url;

    var compareVersions = {exports: {}};

    /* global define */

    (function (module, exports) {
    (function (root, factory) {
      /* istanbul ignore next */
      {
        module.exports = factory();
      }
    }(commonjsGlobal, function () {

      var semver = /^v?(?:\d+)(\.(?:[x*]|\d+)(\.(?:[x*]|\d+)(\.(?:[x*]|\d+))?(?:-[\da-z\-]+(?:\.[\da-z\-]+)*)?(?:\+[\da-z\-]+(?:\.[\da-z\-]+)*)?)?)?$/i;

      function indexOrEnd(str, q) {
        return str.indexOf(q) === -1 ? str.length : str.indexOf(q);
      }

      function split(v) {
        var c = v.replace(/^v/, '').replace(/\+.*$/, '');
        var patchIndex = indexOrEnd(c, '-');
        var arr = c.substring(0, patchIndex).split('.');
        arr.push(c.substring(patchIndex + 1));
        return arr;
      }

      function tryParse(v) {
        return isNaN(Number(v)) ? v : Number(v);
      }

      function validate(version) {
        if (typeof version !== 'string') {
          throw new TypeError('Invalid argument expected string');
        }
        if (!semver.test(version)) {
          throw new Error('Invalid argument not valid semver (\''+version+'\' received)');
        }
      }

      function compareVersions(v1, v2) {
        [v1, v2].forEach(validate);

        var s1 = split(v1);
        var s2 = split(v2);

        for (var i = 0; i < Math.max(s1.length - 1, s2.length - 1); i++) {
          var n1 = parseInt(s1[i] || 0, 10);
          var n2 = parseInt(s2[i] || 0, 10);

          if (n1 > n2) return 1;
          if (n2 > n1) return -1;
        }

        var sp1 = s1[s1.length - 1];
        var sp2 = s2[s2.length - 1];

        if (sp1 && sp2) {
          var p1 = sp1.split('.').map(tryParse);
          var p2 = sp2.split('.').map(tryParse);

          for (i = 0; i < Math.max(p1.length, p2.length); i++) {
            if (p1[i] === undefined || typeof p2[i] === 'string' && typeof p1[i] === 'number') return -1;
            if (p2[i] === undefined || typeof p1[i] === 'string' && typeof p2[i] === 'number') return 1;

            if (p1[i] > p2[i]) return 1;
            if (p2[i] > p1[i]) return -1;
          }
        } else if (sp1 || sp2) {
          return sp1 ? -1 : 1;
        }

        return 0;
      }
      var allowedOperators = [
        '>',
        '>=',
        '=',
        '<',
        '<='
      ];

      var operatorResMap = {
        '>': [1],
        '>=': [0, 1],
        '=': [0],
        '<=': [-1, 0],
        '<': [-1]
      };

      function validateOperator(op) {
        if (typeof op !== 'string') {
          throw new TypeError('Invalid operator type, expected string but got ' + typeof op);
        }
        if (allowedOperators.indexOf(op) === -1) {
          throw new TypeError('Invalid operator, expected one of ' + allowedOperators.join('|'));
        }
      }

      compareVersions.validate = function(version) {
        return typeof version === 'string' && semver.test(version);
      };

      compareVersions.compare = function (v1, v2, operator) {
        // Validate operator
        validateOperator(operator);

        // since result of compareVersions can only be -1 or 0 or 1
        // a simple map can be used to replace switch
        var res = compareVersions(v1, v2);
        return operatorResMap[operator].indexOf(res) > -1;
      };

      return compareVersions;
    }));
    }(compareVersions));

    const version = "3.0.0";
    const VERSION = version;
    const PREFIX = `<!--MN^${version}-->\n`;

    const ObjToUrl = (obj) => {
        const url = urlParse("obsidian://mncomp"), qsObj = {
            version: VERSION,
            body: JsonURL.stringify(obj),
        }, qs = queryString.stringify(qsObj);
        url.set("query", qs);
        return url.toString();
    };
    const ObjToJson = (obj) => PREFIX + JSON.stringify(obj);

    const SendToc = (src) => {
        try {
            send(getBody_Toc(src));
            showHUD(getText("hint_toc_success") + src.noteTitle);
        }
        catch (error) {
            showHUD(error);
        }
    };
    const SendSel = (src) => send(getBody_Sel(src));
    const SendNote = (src) => send(getBody_Note(src));
    const send = (body) => isMac()
        ? copy(ObjToJson(body))
        : Application.sharedInstance().openURL(NSURL.URLWithString(ObjToUrl(body)));

    const onPopupMenuOnNote = (sender) => {
        if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window))
            return; //Don't process message from other window
        if (!self[addonOnName])
            return;
        if (self.recorder === undefined) {
            self.recorder = new PopupRecorder();
        }
        if (!sender.userInfo.note) {
            showHUD("Error: No note in sender");
            return;
        }
        try {
            if (self.recorder.isDuplicate(Date.now()))
                return;
            const note = sender.userInfo.note;
            self.tocMode ? SendToc(note) : SendNote(note);
        }
        catch (error) {
            showHUD(error.toString());
        }
    };
    const onPopupMenuOnSelection = (sender) => {
        if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window))
            return; //Don't process message from other window
        if (!self[addonOnName] || self.tocMode)
            return;
        if (self.recorder === undefined) {
            self.recorder = new PopupRecorder();
        }
        try {
            const { selectionText: sel, document: book } = sender.userInfo.documentController;
            if (sel && sel.length) {
                SendSel({ sel, book });
            }
        }
        catch (error) {
            showHUD(error.toString());
        }
    };
    const bindEventHandlers = (handlerList) => {
        const handlers = {};
        handlerList.forEach((v) => {
            handlers["on" + v.event] = v.handler;
        });
        const add = () => {
            handlerList.forEach((v) => {
                NSNotificationCenter.defaultCenter().addObserverSelectorName(self, `on${v.event}:`, v.event);
            });
        };
        const remove = () => {
            handlerList.forEach((v) => {
                NSNotificationCenter.defaultCenter().removeObserverName(self, v.event);
            });
        };
        return { add, remove, handlers };
    };

    const bindEvt = bindEventHandlers([
        { event: "PopupMenuOnSelection", handler: onPopupMenuOnSelection },
        { event: "PopupMenuOnNote", handler: onPopupMenuOnNote },
    ]);
    const inst = Object.assign(Object.assign({}, bindEvt.handlers), { sceneWillConnect: () => {
            self.tocMode = false;
            self.recorder = new PopupRecorder();
        }, notebookWillOpen: (notebookid) => {
            bindEvt.add();
            self[addonOnName] = NSUserDefaults.standardUserDefaults().objectForKey(`marginnote_${pluginName}`);
            if (self[addonOnName] && self.tocMode)
                showHUD(getText("warn_toc_enabled"));
        }, notebookWillClose: (notebookid) => {
            bindEvt.remove();
        }, queryAddonCommandStatus: () => {
            if (Application.sharedInstance().studyController(self.window).studyMode < 3)
                return {
                    image: "title.png",
                    object: self,
                    selector: toggleHandlerName + ":",
                    checked: self[addonOnName] ? true : false,
                };
            return null;
        }, [toggleHandlerName]: togglePlugin });
    const cls = {};
    JSB.newAddon = (mainPath) => JSB.defineClass(getObjCClassDeclar(pluginName, "JSExtension"), inst, cls);

}());
